Bug 33752

Summary: Assertion failure when getting a href attribute with prefix
Product: WebKit Reporter: Alexey Proskuryakov <ap>
Component: DOMAssignee: Alexey Proskuryakov <ap>
Status: RESOLVED FIXED    
Severity: Normal CC: cdumez, slewis
Priority: P2    
Version: 528+ (Nightly build)   
Hardware: All   
OS: All   
Attachments:
Description Flags
proposed fix darin: review+

Description Alexey Proskuryakov 2010-01-15 19:27:04 PST
NamedNodeMap::getAttributeItem() reasonably assumes that an attribute with null namespace will also have a null prefix. But we actually let one create nodes with null namespace and non-null prefix, due to a bug introduced in <http://trac.webkit.org/changeset/9639>.

Patch forthcoming.
Comment 1 Alexey Proskuryakov 2010-01-15 19:37:49 PST
Created attachment 46727 [details]
proposed fix
Comment 2 Darin Adler 2010-01-16 10:39:37 PST
Comment on attachment 46727 [details]
proposed fix

Normally if you are comparing an atomic string to a string constant, we use an atomic string constant to make the check less expensive.

I suggest we add the strings "xmlns", "http://www.w3.org/2000/xmlns/", and "xml" all to XMLNames.h alongside xmlNamespaceURI and use named constants instead of literal strings.

I'm going to say review+ but I am close to a review- because I'd like us to use atomic strings when comparing with other atomic strings.
Comment 3 Darin Adler 2010-01-16 11:48:34 PST
Comment on attachment 46727 [details]
proposed fix

Oops, I said review+ but then chose review-!
Comment 4 Alexey Proskuryakov 2010-01-16 12:54:27 PST
Committed <http://trac.webkit.org/changeset/53363>.
Comment 5 Lucas Forschler 2019-02-06 09:03:22 PST
Mass moving XML DOM bugs to the "DOM" Component.